// Template for SDCC 8051 C Language

#include <8051.h> // Definitions of registers, SFRs and Bits

#define	BUTTON	P1.0	; Toggle Motor to Turn Left/Right


// ISR Prototypes ===================================================
void INT0_ISR(void)	interrupt 0; // ISR for External Interrupt 0
void T0_ISR(void)	interrupt 1; // ISR for Timer0/Counter0 Overflow
void INT1_ISR(void)	interrupt 2; // ISR for External Interrupt 1
void T1_ISR(void)	interrupt 3; // ISR for Timer1/Counter1 Overflow
void UART_ISR(void)	interrupt 4; // ISR for UART Interrupt

__bit 	DIRECTION;
char	SM;

void main(void)
{
int i;
DIRECTION=0;
SM=0X11;
while(1)
	{
	if(BUTTON==0)
		{
		DIRECTION=1-DIRECTION;
		while(BUTTON==0);
		}
	if(DIRECTION==1)
		{
		tmp=SM%2;
		SM=SM>>1;
		if(tmp==1)
			SM=SM+128;
		P0=SM;	
		}	
	else
		{
		tmp=SM/128;
		SM=SM<<1;
		if(tmp==1)
			SM=SM+1;
		P0=SM;
		}
	for(i=0;i<32767;i++);
	}
}

void INT0_ISR(void)	interrupt 0
{}
void T0_ISR(void)	interrupt 1
{}
void INT1_ISR(void)	interrupt 2
{}
void T1_ISR(void)	interrupt 3
{}
void UART_ISR(void) interrupt 4
{}

